package edu.harvard.mgh.purcell.gplink.base_form;

import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JPanel;

/**
 * An extention of JPanel that holds the buttons of a given form.
 * @author Kathe Todd-Brown
 *
 */
@SuppressWarnings("serial")
public class ButtonPanel extends JPanel {

	/**
	 * buttons that will be shown
	 */
	private JButton filterButton, thresholdButton, okButton, cancelButton;
	/**
	 * form this panel will be used in
	 */
	private Forms parent;
	/**
	 * change the "enabled" property of the ok button.
	 * @param given boolean that you want the button set to
	 */
	public void enableOk(boolean given){
		okButton.setEnabled(given);
	}
	
	/**
	 * Don't let the user us the filter or threshold. It doesn't
	 * make sence on some forms.
	 *
	 */
	public void disableFT(){
		filterButton.setEnabled(false);
		thresholdButton.setEnabled(false);
	}
	
	/**
	 * Constructer
	 * @param p Forms this panel will be created in.
	 */
	public ButtonPanel(Forms p){
		parent = p;
		
		okButton = new JButton("OK");
		//ok is only enabled if the form is valid
		okButton.setEnabled(false);
		okButton.addActionListener(parent.process);
		
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(parent.cancel);
		
		filterButton = new JButton("Filter");
		filterButton.addActionListener(parent.filter);
		
		thresholdButton = new JButton("Threshold");
		thresholdButton.addActionListener(parent.threshold);
		
		//simple layout and add the buttons
		setLayout(new FlowLayout());
		add(filterButton);
		add(thresholdButton);
		add(okButton);
		add(cancelButton);
		
	}
	
}
