package edu.harvard.mgh.purcell.gplink.forms;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ButtonGroup;
import javax.swing.border.TitledBorder;

import edu.harvard.mgh.purcell.gplink.base_form.*;
import edu.harvard.mgh.purcell.gplink.mainGUI.*;

@SuppressWarnings("serial")
public class HFreqForm extends Forms {

	Forms.pickAFileButton hapListBrowse;
	Forms.myRadioButton hapListButton, hapWindowButton;
	Forms.myJTextField hapListText, hapWindowText;

	public HFreqForm(MainFrame mf) {
		super(mf, "Haplotype Frequencies");
	}

	@Override
	protected void createBody() {
		
		body.setLayout(new GridBagLayout());
		body.setBorder(new TitledBorder("Haplotype specification"));
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		body.add(hapListButton, c);
		c.gridx = 1;
		c.weightx = 1;
		body.add(hapListText,c);
		c.weightx = 0;
		c.gridx = 2;
		body.add(hapListBrowse, c);
		c.gridy = 1;
		c.gridx = 0;
		body.add(hapWindowButton, c);
		c.gridwidth = 2;
		c.gridx = 1;
		c.weightx = 1;
		body.add(hapWindowText, c);
	
	}

	@Override
	protected void initalize() {
		hapWindowText = new myJTextField(10);
		hapListText = new myJTextField(20);
		
		hapListBrowse = new pickAFileButton(".hlist", "Haplotype list (*.hlist)", 
				hapListText);
		
		hapWindowButton = new myRadioButton("Sliding window (--hap-window)",
				hapWindowText);
		hapListButton = new myRadioButton("Haplotype list (--hap)", hapListText, 
				hapListBrowse);

		ButtonGroup pickOne = new ButtonGroup();
		pickOne.add(hapWindowButton);
		pickOne.add(hapListButton);
		
	}

	@Override
	protected boolean isBodyValid() {
		if(!(hapListButton.isSelected() || hapWindowButton.isSelected())){
//			information.setText("Must select either --hap-window or --hap flag.");
			return false;
		}
			
		if( hapListButton.isSelected() 
				&& hapListText.getText().length() == 0){
//			information.setText("Must select a file associated with the --hap flag.");
			return false;
			
		}
		if( hapWindowButton.isSelected() 
				 && !hapWindowText.getText().matches("\\d+")){
//			information.setText("Must enter a value associated with " +
//					"the --hap-window flag.");
			return false;
		}
		return true;
		/*
		return ( ( hapListButton.isSelected() 
				  && ( new File(hapListText.getText()).exists() ) ) 
				  || ( hapWindowButton.isSelected() 
						  && !hapWindowText.getText().equals("")));
						  */
	}

	@Override
	protected String processBody() {
		String ans = " --hap-freq";
		if(hapListButton.isSelected())
			ans += " --hap " + GeneralUtil.quoteFilename(hapListText.getText());
		if(hapWindowButton.isSelected())
			ans += " --hap-window " + hapWindowText.getText();
		return ans;
	}

}
